/*
this class implement EM algorithm
*/
#ifndef MCEM_H
#define MCEM_H
#include <string>
#include <iostream>
#include <vector>
#include <string>
#include "Site.h"
#include "MaRatioData.h"
#include "TwoStateSegmentation.h"
#include "utils.h"
#include "HiddenInfo.h"
#include "PriorParam.h"
#include "Args.h"

#include <imsl.h>

using namespace std;

class MCEM{
	public:
	MCEM(PriorParam p,Args a, vector<string> l,int i);
	PriorParam prior;//hyperparameters
	Args args;
	int iteration;//number of iterations for EM
	vector<string> opflist;//list of training files
	string pathraw;
	PriorParam start();

	private:
	void recomputePriorMean();
	void recomputePriorTrans();
	void recomputePriorD();
	void recordSegmentation(list<int> cutPts, list<int> states);
	void recordHiddenInfo(HiddenInfo hinfo);
	void outputstatus(ostream& out);
	void cleanRecord();

	int transCount[5][5];
	int lengthCount[5][3000];
	vector<HiddenInfo> hiddenInfos[5];
};

#endif
