#include "PriorParam.h"
#include "utils.h"
#include <cstdlib>

PriorParam::PriorParam(ifstream& is){
	string line;
	getline(is,line);
	statesize=atoi(ridComment(line).c_str());
	for(int i=0;i<statesize;i++){
		getline(is,line);
		istringstream ss1(ridComment(line));
		ss1>>priormean[i]>>priork[i]>>priornu[i]>>priorsig[i];
	}
	getline(is,line);
	istringstream ss1(ridComment(line));
	for(int i=0;i<statesize;i++)
		for(int j=0;j<statesize;j++)
		ss1>>priortrans[i][j];
	getline(is,line);
	istringstream ss2(ridComment(line));
	for(int i=0;i<statesize;i++) ss2>>priord[i][0]>>priord[i][1];
	getpifromtrans();
}


PriorParam::PriorParam(string fname){
	ifstream is(fname.c_str());
	assert(is);
	string line;
	getline(is,line);
	statesize=atoi(ridComment(line).c_str());
	for(int i=0;i<statesize;i++){
		getline(is,line);
		istringstream ss1(ridComment(line));
		ss1>>priormean[i]>>priork[i]>>priornu[i]>>priorsig[i];
	}
	getline(is,line);
	istringstream ss1(ridComment(line));
	for(int i=0;i<statesize;i++)
		for(int j=0;j<statesize;j++)
		ss1>>priortrans[i][j];
	getline(is,line);
	istringstream ss2(ridComment(line));
	for(int i=0;i<statesize;i++) ss2>>priord[i][0]>>priord[i][1];
	getpifromtrans();
}

void PriorParam::getpifromtrans(){
	for(int i=0;i<statesize;i++){
		priorpi[i]=1/(double)statesize;
	}
}

void PriorParam::normalizeTrans(){
	for (int i=0;i<statesize;i++){
		double sump=0.0;
		for(int j=0;j<statesize;j++) sump+=priortrans[i][j];
		for(int j=0;j<statesize;j++) priortrans[i][j]/=sump;
	}
}


ostream& operator<<(ostream& os, const PriorParam& prior){

	os<<"hyperparameters:"<<endl;
	for(int i=0;i<prior.statesize;i++)
		os<<prior.mean(i)<<" "<<prior.k(i)<<" "<<prior.nu(i)<<" "<<prior.sig(i)<<endl;
	os<<"transition probability:"<<endl;
	for(int i=0;i<prior.statesize;i++)
	  for(int j=0;j<prior.statesize;j++)
	    os<<prior.trans(i,j)<<" ";
	os<<endl<<"alpha and beta:"<<endl;
	for(int i=0;i<prior.statesize;i++)
		os<<prior.d(i,0)<<" "<<prior.d(i,1)<<"   ";
	os<<endl<<endl<<endl;
	return os;
}
